Whamcloud - gitweb
Need to replace the nfs-utils-lustre that was installed with CMD2.
[fs/lustre-release.git] / lustrecvs
1 #!/bin/sh
2
3 LC_COLLATE="C"
4 progname="${0##*/}"
5
6 warn ()
7 {
8     [ "$1" ] && echo >&2
9     [ "$1" ] && echo "$progname: $1" >&2
10     [ "$1" ] && echo >&2
11 }
12
13 fatal ()
14 {
15     warn "$2"
16     exit "$1"
17 }
18
19 usage ()
20 {
21     cat <<EOF
22 Usage: $progname <lustretag>
23   where <lustretag> is a tag of the lustre-core module
24 EOF
25 }
26
27 if [ -z "$LUSTRECVS_UPDATED" ] ; then
28     echo "$progname: updating lustrecvs"
29     cvs up -l || fatal 1 "Error updating lustrecvs"
30     export LUSTRECVS_UPDATED=yes
31     exec "$0" "$@"
32 fi
33
34 [ "$1" = "-r" ] && shift
35
36 buildtag="HEAD"
37 lustretag="$1"
38 shift
39
40 if [ "$*" ] ; then
41     usage >&2
42     exit 1
43 fi
44
45
46 case "$lustretag" in
47     '')
48         warn "a lustretag is required."
49         usage >&2
50         exit 1
51         ;;
52     --help | -h)
53         usage
54         exit 0
55         ;;
56
57     # These releases did not get build tagged for them because they
58     # this build system didn't exist when they were tagged
59     v1_2_8|v1_4_0) 
60         buildtag="b1_4"
61         ;;
62     
63     b1_4*) buildtag="b1_4" ;;
64
65     b_release_1_4_6-patchless) buildtag="b1_4" ;;
66     b_release_1_4_7-test) buildtag="b_release_1_4_7" ;;
67
68     v* | b_release*) buildtag=$lustretag ;;
69
70     # this is the branch table
71     # keep this list sorted alphabetically!
72
73     *)
74         buildtag="HEAD"
75         ;;
76
77 esac
78
79 error_modules=
80 cvs_cmd ()
81 {
82     dir="$1"
83     module="$2"
84     tag="$3"
85     cotag=""
86     update=""
87
88     if [ "$tag" = "HEAD" ] ; then
89         cotag=""
90         uptag="-A"
91     elif [ "$tag" ] ; then
92         cotag="-r $tag"
93         uptag="-r $tag"
94     else
95         # silently skip if no tag was specified
96         return
97     fi
98
99     if [ -d "$dir" ] ; then
100         echo "$progname: Updating $dir to $tag"
101         ( cd "$dir" && cvs up -dP $uptag )
102     else
103         echo "$progname: Checking out $dir from $tag"
104         cvs co -P $cotag -d "$dir" "$module"
105     fi
106     if [ $? != 0 ] ; then
107         error_modules="$dir $error_modules"
108     fi
109 }
110
111 cvs_cmd build lustre-build "$buildtag"
112
113 if [ -f build/buildcvs ] ; then
114     . build/buildcvs
115 else
116     fatal 1 "build/buildcvs does not exist; not updating other modules."
117 fi
118
119 if [ "$error_modules" ] ; then
120     fatal 1 "There were errors checking out the following directories: $error_modules"
121 fi